
randn('state',0);
nVars = 8;
X = randn(100,nVars);
w = randn(nVars,1);
w(3:4) = 0;
w(7:8) = 0;
y = X*w + randn(100,1);
thresh = 1e-8;

doLines = 0;
doColor = 0;

%% Regular L1
w = lars(X,y,'LASSO')';
t = sum(abs(w));

figure(1);clf;gca;hold on;
h2=plot(t,w(2:2:nVars,:));
h1=plot(t,w(1:2:nVars,:));
xlim([0 t(end)]);
set(h1,'LineWidth',2,'Color','r');
set(h2,'LineWidth',2,'Color','b');
if doColor == 0
    set(h1,'Color',[0 0 0]);
    set(h2,'Color',[.7 .7 .7]);
end
legend([h1(1);h2(1)],'real','imag','Location','NorthWest');
%hTitle  = title ('Lasso Regularization Path');
%set( hTitle                    , ...
%    'FontSize'   , 12          , ...
%    'FontWeight' , 'bold'      );
for i = 1:length(t)-1
    realZero = 0;
    complexZero = 0;
    if any(abs(w(1:2:nVars,i+1)) < thresh ~= abs(w(1:2:nVars,i)) < thresh)
        realZero = 1;
    end
    if any(abs(w(2:2:nVars,i+1)) < thresh ~= abs(w(2:2:nVars,i)) < thresh)
        complexZero = 1;
    end
    if doLines
        if realZero && complexZero
            h=vline(t(i));
            set(h,'Color',[.5 1 .5],'LineWidth',1.5);
        elseif realZero
            h=vline(t(i));
            set(h,'Color',[1 .5 .5],'LineWidth',1.5);
        elseif complexZero
            h=vline(t(i));
            set(h,'Color',[.5 .5 1],'LineWidth',1.5);
        end
    end
end
set(gca,'Fontsize',16);

%% Group-L1

% Find Parameters
w = zeros(nVars,1);
i = 1;
t = 0;
funObj = @(w)GaussianLoss(w,X,y);
groups = [1 1 2 2 3 3 4 4]';
opts.spectral = 1;
opts.curvilinear = 0;
opts.verbosity = 0;
for tau = .01:.01:inf
    i = i + 1;
    
    funProjTau = GroupOneNormProject(groups,[],1);
    funProj = @(w) funProjTau(w,tau);
    w(:,i) = spg(funObj,funProj,w(:,i-1),opts);
    
    if sum(abs(w(:,i)-w(:,i-1))) < 1e-4
        break
    end
    t(i,1) = sum(sqrt(accumarray(groups,w(:,i).^2)));
end
w = w(:,1:end-1);

% Plot
figure(2);clf;gca;hold on;
h2=plot(t,w(2:2:nVars,:));
h1=plot(t,w(1:2:nVars,:));
xlim([0 t(end)]);
set(h1,'LineWidth',2,'Color','r');
set(h2,'LineWidth',2,'Color','b');
if doColor == 0
    set(h1,'Color',[0 0 0]);
    set(h2,'Color',[.7 .7 .7]);
end
legend([h1(1);h2(1)],'real','imag','Location','NorthWest');
%hTitle  = title ('Lasso Regularization Path');
%set( hTitle                    , ...
%    'FontSize'   , 12          , ...
%    'FontWeight' , 'bold'      );
for i = 1:length(t)-1
    realZero = 0;
    complexZero = 0;
    if any(abs(w(1:2:nVars,i+1)) < thresh ~= abs(w(1:2:nVars,i)) < thresh)
        realZero = 1;
    end
    if any(abs(w(2:2:nVars,i+1)) < thresh ~= abs(w(2:2:nVars,i)) < thresh)
        complexZero = 1;
    end
    if doLines
        if realZero && complexZero
            h=vline(t(i));
            set(h,'Color',[.5 1 .5],'LineWidth',1.5);
        elseif realZero
            h=vline(t(i));
            set(h,'Color',[1 .5 .5],'LineWidth',1.5);
        elseif complexZero
            h=vline(t(i));
            set(h,'Color',[.5 .5 1],'LineWidth',1.5);
        end
    end
end
set(gca,'Fontsize',16);
wGL1 = w;
