function [adjMatrix] = fixed_Lattice(nRows,nCols,nSlices)
nNodes = nRows*nCols*nSlices;

adjMatrix = sparse(nNodes,nNodes);

% Add Down Edges
ind = 1:nNodes;
for k = 1:nSlices
    exclude = sub2ind([nRows nCols nSlices],repmat(nRows,[1 nCols]),1:nCols,repmat(k,[1 nCols])); % No Down edge for last row
    ind = mysetdiff(ind,exclude);
end
adjMatrix(sub2ind([nNodes nNodes],[ind;ind+1],[ind+1;ind])) = 1;

% Add Right Edges
ind = 1:nNodes;
for k = 1:nSlices
    exclude = sub2ind([nRows nCols nSlices],1:nRows,repmat(nCols,[1 nRows]),repmat(k,[1 nRows])); % No Right edge for last column
    ind = mysetdiff(ind,exclude);
end
adjMatrix(sub2ind([nNodes nNodes],[ind;ind+nCols],[ind+nCols;ind])) = 1;

% Add Back Edges (something is wrong here)
ind = 1:nNodes;
for j = 1:nCols
    exclude = sub2ind([nRows nCols nSlices],1:nRows,repmat(j,[1 nRows]),repmat(nSlices,[1 nRows]));
    ind = mysetdiff(ind,exclude);
end
adjMatrix(sub2ind([nNodes nNodes],[ind;ind+nCols*nRows],[ind+nCols*nRows;ind])) = 1;
