#include <math.h>
#include "mex.h"
#include "UGM_common.h"

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
    /* Variables */
    int i,f,n1,n2,e,*edgeEnds,outputSize[3],
    nInstances,nEdges,nFeatures;
    
    double *X,*Xedge;
    
    /* Input */
    X = mxGetPr(prhs[0]);
    edgeEnds = mxGetPr(prhs[1]);
    
    /* Compute Sizes */
    nInstances = mxGetDimensions(prhs[0])[0];
    nFeatures = mxGetDimensions(prhs[0])[1];
    nEdges = mxGetDimensions(prhs[1])[0];
    decrementEdgeEnds(edgeEnds,nEdges);
    
    /* Output */
    outputSize[0] = nInstances;
    outputSize[1] = nFeatures*2;
    outputSize[2] = nEdges;
    plhs[0] = mxCreateNumericArray(3,outputSize,mxDOUBLE_CLASS,mxREAL);
    Xedge = mxGetPr(plhs[0]);
    
    /* You reference Xedge as Xedge[i + nInstances*(f + nFeatures*2*e] */
    for(i = 0; i < nInstances; i++)
    {
        for(e = 0; e < nEdges; e++)
        {
            n1 = edgeEnds[e];
            n2 = edgeEnds[e+nEdges];
            for(f = 0; f < nFeatures; f++)
            {
                Xedge[i+nInstances*(f+nFeatures*2*e)] = X[i+nInstances*(f+nFeatures*n1)];
                Xedge[i+nInstances*(f+nFeatures+nFeatures*2*e)] = X[i+nInstances*(f+nFeatures*n2)];
            }
        }
    }

}
