function [samples] = UGM_Sample_Block_Gibbs(nodePot,edgePot,edgeStruct,infoStruct,blocks,sampleFunc)
% Block Gibbs Sampling

[nNodes,maxStates] = size(nodePot);
nEdges = size(edgePot,3);
edgeEnds = edgeStruct.edgeEnds;
V = edgeStruct.V;
E = edgeStruct.E;
nStates = infoStruct.nStates;
maxIter = infoStruct.maxIter;

% Initialize
nBlocks = length(blocks);
[junk y] = max(nodePot,[],2);

samples = zeros(nNodes,0);

for i = 1:maxIter

    for b = 1:nBlocks
        clamped = y;
        clamped(blocks{b}) = 0;
    
        [clampedNP,clampedEP,clampedES,clampedIS] = UGM_makeClampedPotentials(nodePot, edgePot, edgeStruct, infoStruct, clamped);

        clampedIS.maxIter = 1;
        y(blocks{b}) = sampleFunc(clampedNP,clampedEP,clampedES,clampedIS);
    end
    samples(:,i) = y;
end